diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-mlo-test.cc ns-3.40/src/wifi/test/wifi-mlo-test.cc
--- ns-3.39/src/wifi/test/wifi-mlo-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-mlo-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -19,9 +19,8 @@
 
 #include "ns3/ap-wifi-mac.h"
 #include "ns3/config.h"
-#include "ns3/he-configuration.h"
-#include "ns3/he-frame-exchange-manager.h"
-#include "ns3/he-phy.h"
+#include "ns3/eht-configuration.h"
+#include "ns3/frame-exchange-manager.h"
 #include "ns3/log.h"
 #include "ns3/mgt-headers.h"
 #include "ns3/mobility-helper.h"
@@ -54,6 +53,7 @@
 #include <iomanip>
 #include <optional>
 #include <sstream>
+#include <tuple>
 #include <vector>
 
 using namespace ns3;
@@ -193,6 +193,121 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * Test the WifiMac::SwapLinks() method.
+ */
+class MldSwapLinksTest : public TestCase
+{
+    /**
+     * Test WifiMac subclass used to access the SwapLinks method.
+     */
+    class TestWifiMac : public WifiMac
+    {
+      public:
+        ~TestWifiMac() override = default;
+
+        using WifiMac::GetLinks;
+        using WifiMac::SwapLinks;
+
+        bool CanForwardPacketsTo(Mac48Address to) const override
+        {
+            return true;
+        }
+
+        void Enqueue(Ptr<Packet> packet, Mac48Address to) override
+        {
+        }
+    };
+
+  public:
+    MldSwapLinksTest();
+    ~MldSwapLinksTest() override = default;
+
+  protected:
+    void DoRun() override;
+
+  private:
+    /**
+     * Run a single test case.
+     *
+     * \param text string identifying the test case
+     * \param nLinks the number of links of the MLD
+     * \param links a set of pairs (from, to) each mapping a current link ID to the
+     *              link ID it has to become (i.e., link 'from' becomes link 'to')
+     * \param expected maps each link ID to the id of the PHY that is expected
+     *                 to operate on that link after the swap
+     */
+    void RunOne(std::string text,
+                std::size_t nLinks,
+                const std::map<uint8_t, uint8_t>& links,
+                const std::map<uint8_t, uint8_t>& expected);
+};
+
+MldSwapLinksTest::MldSwapLinksTest()
+    : TestCase("Test the WifiMac::SwapLinks() method")
+{
+}
+
+void
+MldSwapLinksTest::RunOne(std::string text,
+                         std::size_t nLinks,
+                         const std::map<uint8_t, uint8_t>& links,
+                         const std::map<uint8_t, uint8_t>& expected)
+{
+    TestWifiMac mac;
+
+    std::vector<Ptr<WifiPhy>> phys;
+    for (std::size_t i = 0; i < nLinks; i++)
+    {
+        phys.emplace_back(CreateObject<SpectrumWifiPhy>());
+    }
+    mac.SetWifiPhys(phys); // create links containing the given PHYs
+
+    mac.SwapLinks(links);
+
+    NS_TEST_EXPECT_MSG_EQ(mac.GetNLinks(), nLinks, "Number of links changed after swapping");
+
+    for (const auto& [linkId, phyId] : expected)
+    {
+        NS_TEST_ASSERT_MSG_EQ(mac.GetLinks().count(linkId),
+                              1,
+                              "Link ID " << +linkId << " does not exist");
+
+        NS_TEST_ASSERT_MSG_LT(+phyId, nLinks, "Invalid PHY ID");
+
+        // the id of the PHY operating on a link is the original ID of the link
+        NS_TEST_EXPECT_MSG_EQ(mac.GetWifiPhy(linkId),
+                              phys.at(phyId),
+                              text << ": Link " << +phyId << " has not been moved to link "
+                                   << +linkId);
+    }
+}
+
+void
+MldSwapLinksTest::DoRun()
+{
+    RunOne("No change needed", 3, {{0, 0}, {1, 1}, {2, 2}}, {{0, 0}, {1, 1}, {2, 2}});
+    RunOne("Circular swapping", 3, {{0, 2}, {1, 0}, {2, 1}}, {{0, 1}, {1, 2}, {2, 0}});
+    RunOne("Swapping two links, one unchanged", 3, {{0, 2}, {2, 0}}, {{0, 2}, {1, 1}, {2, 0}});
+    RunOne("Non-circular swapping, autodetect how to close the loop",
+           3,
+           {{0, 2}, {2, 1}},
+           {{0, 1}, {1, 2}, {2, 0}});
+    RunOne("One move only, autodetect how to complete the swapping",
+           3,
+           {{2, 0}},
+           {{0, 2}, {1, 1}, {2, 0}});
+    RunOne("Create a new link ID (2), remove the unused one (0)",
+           2,
+           {{0, 1}, {1, 2}},
+           {{1, 0}, {2, 1}});
+    RunOne("One move only that creates a new link ID (2)", 2, {{0, 2}}, {{1, 1}, {2, 0}});
+    RunOne("Move all links to a new set of IDs", 2, {{0, 2}, {1, 3}}, {{2, 0}, {3, 1}});
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Base class for Multi-Link Operations tests
  *
  * Three spectrum channels are created, one for each band (2.4 GHz, 5 GHz and 6 GHz).
@@ -203,37 +318,70 @@
 {
   public:
     /**
+     * Configuration parameters common to all subclasses
+     */
+    struct BaseParams
+    {
+        std::vector<std::string>
+            staChannels; //!< the strings specifying the operating channels for the non-AP MLD
+        std::vector<std::string>
+            apChannels; //!< the strings specifying the operating channels for the AP MLD
+        std::vector<uint8_t>
+            fixedPhyBands; //!< list of IDs of non-AP MLD PHYs that cannot switch band
+    };
+
+    /**
      * Constructor
      *
      * \param name The name of the new TestCase created
      * \param nStations the number of stations to create
-     * \param staChannels the strings specifying the operating channels for the STA
-     * \param apChannels the strings specifying the operating channels for the AP
-     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
+     * \param baseParams common configuration parameters
      */
     MultiLinkOperationsTestBase(const std::string& name,
                                 uint8_t nStations,
-                                std::vector<std::string> staChannels,
-                                std::vector<std::string> apChannels,
-                                std::vector<uint8_t> fixedPhyBands = {});
+                                const BaseParams& baseParams);
     ~MultiLinkOperationsTestBase() override = default;
 
   protected:
     /**
      * Callback invoked when a FEM passes PSDUs to the PHY.
      *
-     * \param linkId the ID of the link transmitting the PSDUs
-     * \param context the context
+     * \param mac the MAC transmitting the PSDUs
+     * \param phyId the ID of the PHY transmitting the PSDUs
      * \param psduMap the PSDU map
      * \param txVector the TX vector
      * \param txPowerW the tx power in Watts
      */
-    virtual void Transmit(uint8_t linkId,
-                          std::string context,
+    virtual void Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
                           WifiConstPsduMap psduMap,
                           WifiTxVector txVector,
                           double txPowerW);
 
+    /**
+     * Function to trace packets received by the server application
+     * \param nodeId the ID of the node that received the packet
+     * \param p the packet
+     * \param addr the address
+     */
+    virtual void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
+
+    /**
+     * \param sockAddr the packet socket address identifying local outgoing interface
+     *                 and remote address
+     * \param count the number of packets to generate
+     * \param pktSize the size of the packets to generate
+     * \param delay the delay with which traffic generation starts
+     * \param priority user priority for generated packets
+     * \return an application generating the given number packets of the given size destined
+     *         to the given packet socket address
+     */
+    Ptr<PacketSocketClient> GetApplication(const PacketSocketAddress& sockAddr,
+                                           std::size_t count,
+                                           std::size_t pktSize,
+                                           Time delay = Seconds(0),
+                                           uint8_t priority = 0) const;
+
     void DoSetup() override;
 
     /// PHY band-indexed map of spectrum channels
@@ -264,6 +412,7 @@
         WifiConstPsduMap psduMap; ///< transmitted PSDU map
         WifiTxVector txVector;    ///< TXVECTOR
         uint8_t linkId;           ///< link ID
+        uint8_t phyId;            ///< ID of the transmitting PHY
     };
 
     std::vector<FrameInfo> m_txPsdus;             ///< transmitted PSDUs
@@ -274,6 +423,9 @@
     std::vector<Ptr<StaWifiMac>> m_staMacs;       ///< STA wifi MACs
     uint8_t m_nStations;                          ///< number of stations to create
     uint16_t m_lastAid;                           ///< AID of last associated station
+    Time m_duration{Seconds(1)};                  ///< simulation duration
+    std::vector<std::size_t> m_rxPkts; ///< number of packets received at application layer
+                                       ///< by each node (index is node ID)
 
   private:
     /**
@@ -308,16 +460,15 @@
 
 MultiLinkOperationsTestBase::MultiLinkOperationsTestBase(const std::string& name,
                                                          uint8_t nStations,
-                                                         std::vector<std::string> staChannels,
-                                                         std::vector<std::string> apChannels,
-                                                         std::vector<uint8_t> fixedPhyBands)
+                                                         const BaseParams& baseParams)
     : TestCase(name),
-      m_staChannels(staChannels),
-      m_apChannels(apChannels),
-      m_fixedPhyBands(fixedPhyBands),
+      m_staChannels(baseParams.staChannels),
+      m_apChannels(baseParams.apChannels),
+      m_fixedPhyBands(baseParams.fixedPhyBands),
       m_staMacs(nStations),
       m_nStations(nStations),
-      m_lastAid(0)
+      m_lastAid(0),
+      m_rxPkts(nStations + 1)
 {
 }
 
@@ -374,7 +525,7 @@
         bool found = false;
         for (uint8_t i = 0; i < m_nStations; i++)
         {
-            for (uint8_t linkId = 0; linkId < m_staMacs[i]->GetNLinks(); linkId++)
+            for (const auto& linkId : m_staMacs[i]->GetLinkIds())
             {
                 if (m_staMacs[i]->GetFrameExchangeManager(linkId)->GetAddress() == *staAddr)
                 {
@@ -395,21 +546,24 @@
 }
 
 void
-MultiLinkOperationsTestBase::Transmit(uint8_t linkId,
-                                      std::string context,
+MultiLinkOperationsTestBase::Transmit(Ptr<WifiMac> mac,
+                                      uint8_t phyId,
                                       WifiConstPsduMap psduMap,
                                       WifiTxVector txVector,
                                       double txPowerW)
 {
-    m_txPsdus.push_back({Simulator::Now(), psduMap, txVector, linkId});
+    auto linkId = mac->GetLinkForPhy(phyId);
+    NS_TEST_ASSERT_MSG_EQ(linkId.has_value(), true, "No link found for PHY ID " << +phyId);
+    m_txPsdus.push_back({Simulator::Now(), psduMap, txVector, *linkId, phyId});
 
     for (const auto& [aid, psdu] : psduMap)
     {
         std::stringstream ss;
-        ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID " << +linkId << " "
-           << psdu->GetHeader(0).GetTypeString() << " #MPDUs " << psdu->GetNMpdus()
-           << " duration/ID " << psdu->GetHeader(0).GetDuration() << " RA = " << psdu->GetAddr1()
-           << " TA = " << psdu->GetAddr2() << " ADDR3 = " << psdu->GetHeader(0).GetAddr3()
+        ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID "
+           << +linkId.value() << " Phy ID " << +phyId << " " << psdu->GetHeader(0).GetTypeString()
+           << " #MPDUs " << psdu->GetNMpdus() << " duration/ID " << psdu->GetHeader(0).GetDuration()
+           << " RA = " << psdu->GetAddr1() << " TA = " << psdu->GetAddr2()
+           << " ADDR3 = " << psdu->GetHeader(0).GetAddr3()
            << " ToDS = " << psdu->GetHeader(0).IsToDs()
            << " FromDS = " << psdu->GetHeader(0).IsFromDs();
         if (psdu->GetHeader(0).IsQosData())
@@ -427,6 +581,13 @@
 }
 
 void
+MultiLinkOperationsTestBase::L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr)
+{
+    NS_LOG_INFO("Packet received by NODE " << +nodeId << "\n");
+    m_rxPkts[nodeId]++;
+}
+
+void
 MultiLinkOperationsTestBase::SetChannels(SpectrumWifiPhyHelper& helper,
                                          const std::vector<std::string>& channels,
                                          const ChannelMap& channelMap)
@@ -526,31 +687,79 @@
     }
 
     // Trace PSDUs passed to the PHY on all devices
-    for (uint8_t linkId = 0; linkId < StaticCast<WifiNetDevice>(apDevices.Get(0))->GetNPhys();
-         linkId++)
+    for (uint8_t phyId = 0; phyId < m_apMac->GetDevice()->GetNPhys(); phyId++)
     {
-        Config::Connect("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
-                            std::to_string(linkId) + "/PhyTxPsduBegin",
-                        MakeCallback(&MultiLinkOperationsTestBase::Transmit, this).Bind(linkId));
+        Config::ConnectWithoutContext(
+            "/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phys/" + std::to_string(phyId) +
+                "/PhyTxPsduBegin",
+            MakeCallback(&MultiLinkOperationsTestBase::Transmit, this).Bind(m_apMac, phyId));
     }
     for (uint8_t i = 0; i < m_nStations; i++)
     {
-        for (uint8_t linkId = 0; linkId < StaticCast<WifiNetDevice>(staDevices.Get(i))->GetNPhys();
-             linkId++)
+        for (uint8_t phyId = 0; phyId < m_staMacs[i]->GetDevice()->GetNPhys(); phyId++)
         {
-            Config::Connect(
-                "/NodeList/" + std::to_string(i + 1) + "/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
-                    std::to_string(linkId) + "/PhyTxPsduBegin",
-                MakeCallback(&MultiLinkOperationsTestBase::Transmit, this).Bind(linkId));
+            Config::ConnectWithoutContext("/NodeList/" + std::to_string(i + 1) +
+                                              "/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
+                                              std::to_string(phyId) + "/PhyTxPsduBegin",
+                                          MakeCallback(&MultiLinkOperationsTestBase::Transmit, this)
+                                              .Bind(m_staMacs[i], phyId));
         }
     }
 
+    // install packet socket on all nodes
+    PacketSocketHelper packetSocket;
+    packetSocket.Install(wifiApNode);
+    packetSocket.Install(wifiStaNodes);
+
+    // install a packet socket server on all nodes
+    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); ++nodeIt)
+    {
+        PacketSocketAddress srvAddr;
+        auto device = DynamicCast<WifiNetDevice>((*nodeIt)->GetDevice(0));
+        NS_TEST_ASSERT_MSG_NE(device, nullptr, "Expected a WifiNetDevice");
+        srvAddr.SetSingleDevice(device->GetIfIndex());
+        srvAddr.SetProtocol(1);
+
+        auto server = CreateObject<PacketSocketServer>();
+        server->SetLocal(srvAddr);
+        (*nodeIt)->AddApplication(server);
+        server->SetStartTime(Seconds(0)); // now
+        server->SetStopTime(m_duration);
+    }
+
+    for (std::size_t nodeId = 0; nodeId < NodeList::GetNNodes(); nodeId++)
+    {
+        Config::ConnectWithoutContext(
+            "/NodeList/" + std::to_string(nodeId) +
+                "/ApplicationList/*/$ns3::PacketSocketServer/Rx",
+            MakeCallback(&MultiLinkOperationsTestBase::L7Receive, this).Bind(nodeId));
+    }
+
     // schedule ML setup for one station at a time
     m_apMac->TraceConnectWithoutContext("AssociatedSta",
                                         MakeCallback(&MultiLinkOperationsTestBase::SetSsid, this));
     m_staMacs[0]->SetSsid(Ssid("ns-3-ssid"));
 }
 
+Ptr<PacketSocketClient>
+MultiLinkOperationsTestBase::GetApplication(const PacketSocketAddress& sockAddr,
+                                            std::size_t count,
+                                            std::size_t pktSize,
+                                            Time delay,
+                                            uint8_t priority) const
+{
+    auto client = CreateObject<PacketSocketClient>();
+    client->SetAttribute("PacketSize", UintegerValue(pktSize));
+    client->SetAttribute("MaxPackets", UintegerValue(count));
+    client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+    client->SetAttribute("Priority", UintegerValue(priority));
+    client->SetRemote(sockAddr);
+    client->SetStartTime(delay);
+    client->SetStopTime(m_duration - Simulator::Now());
+
+    return client;
+}
+
 void
 MultiLinkOperationsTestBase::SetSsid(uint16_t aid, Mac48Address /* addr */)
 {
@@ -583,6 +792,23 @@
  * switch PHY band (if any). The links that are expected to be setup are also provided as input
  * parameters. This test verifies that the management frames exchanged during ML discovery
  * and ML setup contain the expected values and that the two MLDs setup the expected links.
+ *
+ * The negotiated TID-to-link mapping is tested by verifying that generated QoS data frames of
+ * a given TID are transmitted on links which the TID is mapped to. Specifically, the following
+ * operations are performed separately for each direction (downlink and uplink). A first TID
+ * is searched such that it is not mapped on all the setup links. If no such TID is found, only
+ * QoS frames of TID 0 are generated. Otherwise, we also search for a second TID that is mapped
+ * to a link set that is disjoint with the link set to which the first TID is mapped. If such a
+ * TID is found, QoS frames of both the first TID and the second TID are generated; otherwise,
+ * only QoS frames of the first TID are generated. For each TID, a number of QoS frames equal
+ * to the number of setup links is generated. For each TID, we check that the first N QoS frames,
+ * where N is the size of the link set to which the TID is mapped, are transmitted concurrently,
+ * while the following QoS frames are sent after the first QoS frame sent on the same link. We
+ * also check that all the QoS frames are sent on a link belonging to the link set to which the
+ * TID is mapped. If QoS frames of two TIDs are generated, we also check that the first N QoS
+ * frames of a TID, where N is the size of the link set to which that TID is mapped, are sent
+ * concurrently with the first M QoS frames of the other TID, where M is the size of the link
+ * set to which the other TID is mapped.
  */
 class MultiLinkSetupTest : public MultiLinkOperationsTestBase
 {
@@ -590,17 +816,20 @@
     /**
      * Constructor
      *
-     * \param staChannels the strings specifying the operating channels for the STA
-     * \param apChannels the strings specifying the operating channels for the AP
+     * \param baseParams common configuration parameters
      * \param scanType the scan type (active or passive)
-     * \param setupLinks a list of links (STA link ID, AP link ID) that are expected to be setup
-     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
+     * \param setupLinks a list of links that are expected to be setup. In case one of the two
+     *                   devices has a single link, the ID of the link on the MLD is indicated
+     * \param apNegSupport TID-to-Link Mapping negotiation supported by the AP MLD (0, 1, or 3)
+     * \param dlTidToLinkMapping DL TID-to-Link Mapping for EHT configuration of non-AP MLD
+     * \param ulTidToLinkMapping UL TID-to-Link Mapping for EHT configuration of non-AP MLD
      */
-    MultiLinkSetupTest(std::vector<std::string> staChannels,
-                       std::vector<std::string> apChannels,
+    MultiLinkSetupTest(const BaseParams& baseParams,
                        WifiScanType scanType,
-                       std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
-                       std::vector<uint8_t> fixedPhyBands = {});
+                       const std::vector<uint8_t>& setupLinks,
+                       uint8_t apNegSupport,
+                       const std::string& dlTidToLinkMapping,
+                       const std::string& ulTidToLinkMapping);
     ~MultiLinkSetupTest() override = default;
 
   protected:
@@ -608,6 +837,8 @@
     void DoRun() override;
 
   private:
+    void StartTraffic() override;
+
     /**
      * Check correctness of Multi-Link Setup procedure.
      */
@@ -650,25 +881,48 @@
      */
     void CheckAssocResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
 
-    /// expected links to setup (STA link ID, AP link ID)
-    const std::vector<std::pair<uint8_t, uint8_t>> m_setupLinks;
-    WifiScanType m_scanType;  //!< the scan type (active or passive)
-    std::size_t m_nProbeResp; //!< number of Probe Responses received by the non-AP MLD
+    /**
+     * Check that QoS data frames are sent on links their TID is mapped to.
+     *
+     * \param mpdu the given QoS data frame
+     * \param linkId the ID of the link on which the QoS data frame was transmitted
+     * \param index index of the QoS data frame in the vector of transmitted PSDUs
+     */
+    void CheckQosData(Ptr<WifiMpdu> mpdu, uint8_t linkId, std::size_t index);
+
+    const std::vector<uint8_t> m_setupLinks; //!< IDs of the expected links to setup
+    WifiScanType m_scanType;                 //!< the scan type (active or passive)
+    std::size_t m_nProbeResp;          //!< number of Probe Responses received by the non-AP MLD
+    uint8_t m_apNegSupport;            //!< TID-to-Link Mapping negotiation supported by the AP MLD
+    std::string m_dlTidLinkMappingStr; //!< DL TID-to-Link Mapping for non-AP MLD EHT configuration
+    std::string m_ulTidLinkMappingStr; //!< UL TID-to-Link Mapping for non-AP MLD EHT configuration
+    WifiTidLinkMapping m_dlTidLinkMapping; //!< expected DL TID-to-Link Mapping requested by non-AP
+                                           //!< MLD and accepted by AP MLD
+    WifiTidLinkMapping m_ulTidLinkMapping; //!< expected UL TID-to-Link Mapping requested by non-AP
+                                           //!< MLD and accepted by AP MLD
+    uint8_t m_dlTid1;                      //!< the TID of the first set of DL QoS data frames
+    uint8_t m_ulTid1;                      //!< the TID of the first set of UL QoS data frames
+    std::optional<uint8_t> m_dlTid2;       //!< the TID of the optional set of DL QoS data frames
+    std::optional<uint8_t> m_ulTid2;       //!< the TID of the optional set of UL QoS data frames
+    std::vector<std::size_t>
+        m_qosFrames1; //!< indices of QoS frames of the first set in the vector of TX PSDUs
+    std::vector<std::size_t>
+        m_qosFrames2; //!< indices of QoS frames of the optional set in the vector of TX PSDUs
 };
 
-MultiLinkSetupTest::MultiLinkSetupTest(std::vector<std::string> staChannels,
-                                       std::vector<std::string> apChannels,
+MultiLinkSetupTest::MultiLinkSetupTest(const BaseParams& baseParams,
                                        WifiScanType scanType,
-                                       std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
-                                       std::vector<uint8_t> fixedPhyBands)
-    : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup",
-                                  1,
-                                  staChannels,
-                                  apChannels,
-                                  fixedPhyBands),
+                                       const std::vector<uint8_t>& setupLinks,
+                                       uint8_t apNegSupport,
+                                       const std::string& dlTidToLinkMapping,
+                                       const std::string& ulTidToLinkMapping)
+    : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup", 1, baseParams),
       m_setupLinks(setupLinks),
       m_scanType(scanType),
-      m_nProbeResp(0)
+      m_nProbeResp(0),
+      m_apNegSupport(apNegSupport),
+      m_dlTidLinkMappingStr(dlTidToLinkMapping),
+      m_ulTidLinkMappingStr(ulTidToLinkMapping)
 {
 }
 
@@ -678,6 +932,137 @@
     MultiLinkOperationsTestBase::DoSetup();
 
     m_staMacs[0]->SetAttribute("ActiveProbing", BooleanValue(m_scanType == WifiScanType::ACTIVE));
+    m_apMac->GetEhtConfiguration()->SetAttribute("TidToLinkMappingNegSupport",
+                                                 EnumValue(m_apNegSupport));
+    // For non-AP MLD, it does not make sense to set the negotiation type to 0 (unless the AP MLD
+    // also advertises 0) or 1 (the AP MLD is discarded if it advertises a support of 3)
+    auto staEhtConfig = m_staMacs[0]->GetEhtConfiguration();
+    staEhtConfig->SetAttribute("TidToLinkMappingNegSupport", EnumValue(3));
+    staEhtConfig->SetAttribute("TidToLinkMappingDl", StringValue(m_dlTidLinkMappingStr));
+    staEhtConfig->SetAttribute("TidToLinkMappingUl", StringValue(m_ulTidLinkMappingStr));
+
+    // the negotiated link mapping matches the one configured in EHT configuration, unless
+    // the AP MLD does not support TID-to-link mapping negotiation or the AP MLD supports
+    // the negotiation type 1 and the non-AP MLD is configured with a link mapping that
+    // maps distinct link sets to the TIDs, in which case the default link mapping is used
+    m_dlTidLinkMapping = staEhtConfig->GetTidLinkMapping(WifiDirection::DOWNLINK);
+    m_ulTidLinkMapping = staEhtConfig->GetTidLinkMapping(WifiDirection::UPLINK);
+
+    if (m_apNegSupport == 0 ||
+        (m_apNegSupport == 1 &&
+         !TidToLinkMappingValidForNegType1(m_dlTidLinkMapping, m_ulTidLinkMapping)))
+    {
+        m_dlTidLinkMapping.clear(); // default link mapping
+        m_ulTidLinkMapping.clear(); // default link mapping
+    }
+
+    // find (if any) a TID that is not mapped to all setup links
+    using TupleRefs = std::tuple<std::reference_wrapper<const WifiTidLinkMapping>,
+                                 std::reference_wrapper<uint8_t>,
+                                 std::reference_wrapper<std::optional<uint8_t>>,
+                                 Ptr<WifiMac>>;
+    for (auto& [mappingRef, tid1Ref, tid2Ref, mac] :
+         {TupleRefs{m_dlTidLinkMapping, m_dlTid1, m_dlTid2, m_apMac},
+          TupleRefs{m_ulTidLinkMapping, m_ulTid1, m_ulTid2, m_staMacs[0]}})
+    {
+        tid1Ref.get() = 0;
+        for (uint8_t tid1 = 0; tid1 < 8; tid1++)
+        {
+            if (auto it1 = mappingRef.get().find(tid1);
+                it1 != mappingRef.get().cend() && it1->second.size() != m_setupLinks.size())
+            {
+                // found. Now search for another TID with a disjoint mapped link set
+                for (uint8_t tid2 = tid1 + 1; tid2 < 8; tid2++)
+                {
+                    if (auto it2 = mappingRef.get().find(tid2);
+                        it2 != mappingRef.get().cend() && it2->second.size() != m_setupLinks.size())
+                    {
+                        std::list<uint8_t> intersection;
+                        std::set_intersection(it1->second.cbegin(),
+                                              it1->second.cend(),
+                                              it2->second.cbegin(),
+                                              it2->second.cend(),
+                                              std::back_inserter(intersection));
+                        if (intersection.empty())
+                        {
+                            // found a second TID
+                            tid2Ref.get() = tid2;
+                            break;
+                        }
+                    }
+                }
+                tid1Ref.get() = tid1;
+                break;
+            }
+        }
+
+        std::list<uint8_t> tids = {tid1Ref.get()};
+        if (tid2Ref.get())
+        {
+            tids.emplace_back(*tid2Ref.get());
+        }
+
+        // prevent aggregation of MPDUs
+        for (auto tid : tids)
+        {
+            std::string attrName;
+            switch (QosUtilsMapTidToAc(tid))
+            {
+            case AC_VI:
+                attrName = "VI_MaxAmpduSize";
+                break;
+            case AC_VO:
+                attrName = "VO_MaxAmpduSize";
+                break;
+            case AC_BE:
+                attrName = "BE_MaxAmpduSize";
+                break;
+            case AC_BK:
+                attrName = "BK_MaxAmpduSize";
+                break;
+            default:
+                NS_FATAL_ERROR("Invalid TID " << +tid);
+            }
+
+            mac->SetAttribute(attrName, UintegerValue(100));
+        }
+    }
+}
+
+void
+MultiLinkSetupTest::StartTraffic()
+{
+    // DL traffic
+    {
+        PacketSocketAddress sockAddr;
+        sockAddr.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+        sockAddr.SetPhysicalAddress(m_staMacs[0]->GetDevice()->GetAddress());
+        sockAddr.SetProtocol(1);
+
+        m_apMac->GetDevice()->GetNode()->AddApplication(
+            GetApplication(sockAddr, m_setupLinks.size(), 500, Seconds(0), m_dlTid1));
+        if (m_dlTid2)
+        {
+            m_apMac->GetDevice()->GetNode()->AddApplication(
+                GetApplication(sockAddr, m_setupLinks.size(), 500, Seconds(0), *m_dlTid2));
+        }
+    }
+
+    // UL Traffic
+    {
+        PacketSocketAddress sockAddr;
+        sockAddr.SetSingleDevice(m_staMacs[0]->GetDevice()->GetIfIndex());
+        sockAddr.SetPhysicalAddress(m_apMac->GetDevice()->GetAddress());
+        sockAddr.SetProtocol(1);
+
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
+            GetApplication(sockAddr, m_setupLinks.size(), 500, MilliSeconds(500), m_ulTid1));
+        if (m_ulTid2)
+        {
+            m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
+                GetApplication(sockAddr, m_setupLinks.size(), 500, MilliSeconds(500), *m_ulTid2));
+        }
+    }
 }
 
 void
@@ -685,12 +1070,14 @@
 {
     Simulator::Schedule(MilliSeconds(500), &MultiLinkSetupTest::CheckMlSetup, this);
 
-    Simulator::Stop(Seconds(1.5));
+    Simulator::Stop(m_duration);
     Simulator::Run();
 
     /**
      * Check content of management frames
      */
+    std::size_t index = 0;
+
     for (const auto& frameInfo : m_txPsdus)
     {
         const auto& mpdu = *frameInfo.psduMap.begin()->second->begin();
@@ -715,9 +1102,15 @@
             CheckAssocResponse(mpdu, linkId);
             break;
 
+        case WIFI_MAC_QOSDATA:
+            CheckQosData(mpdu, linkId, index);
+            break;
+
         default:
             break;
         }
+
+        index++;
     }
 
     CheckDisabledLinks();
@@ -742,6 +1135,24 @@
 
     NS_TEST_EXPECT_MSG_EQ(m_nProbeResp, expectedProbeResp, "Unexpected number of Probe Responses");
 
+    std::size_t expectedRxDlPkts = m_setupLinks.size();
+    if (m_dlTid2)
+    {
+        expectedRxDlPkts *= 2;
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_rxPkts[m_staMacs[0]->GetDevice()->GetNode()->GetId()],
+                          expectedRxDlPkts,
+                          "Unexpected number of DL packets received");
+
+    std::size_t expectedRxUlPkts = m_setupLinks.size();
+    if (m_ulTid2)
+    {
+        expectedRxUlPkts *= 2;
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_rxPkts[m_apMac->GetDevice()->GetNode()->GetId()],
+                          expectedRxUlPkts,
+                          "Unexpected number of UL packets received");
+
     Simulator::Destroy();
 }
 
